#ifndef __bVIDEO_h
#define __bVIDEO_h

#include <cstdio>		/* sprintf */
#include <string>
#include <termio.h>
#include <sys/ioctl.h>
#include <sstream>

using namespace std;

extern int COLS, LINES;

extern class Video
{
private:
	int wx,wy;
#ifndef linux	
	enum {Single,Double,Normal} set;
#endif
	unsigned char TextAttr;
	void ShowCurs(const bool c);
	void GetScreenGeometry() const;
	void SetAttr(unsigned char n);
#ifndef linux
	void SingleSet();
	void DoubleSet();
	void NormalSet();
#endif
	unsigned char *mbuf, *cbuf;
	struct termio back;
	bool isactive;
	void GenInit();
	void Close();
	int wv, wv1, wv2;
public:
	Video(bool active=true);
	Video(const Video &src);
	~Video();
	
	void Copy(const Video &src);

	void clear();
	
	Video &operator=(const unsigned char attr) { SetAttr(attr);return *this; }
	inline Video &operator << (const string &s) { return *this << s.c_str(); }
	Video &operator << (const int a)      { char Buf[10]; sprintf(Buf,"%d",a); return *this << Buf; }
	Video &operator << (const unsigned a) { char Buf[10]; sprintf(Buf,"%u",a); return *this << Buf; }
	inline Video &operator << (const unsigned char c)
	{ return *this << (const char)c; }
	Video &operator << (const char *s)
	{
		while(s&&*s)*this << *s++;
		return *this;
	}
	Video &operator << (char c);
	
	void Flush();
	unsigned char getkey(int wait=0);
	
	inline const int &wherey() { return wy; }
	inline const int &wherex() { return wx; }
	Video &Goto(int y, int x, const int v=-1);
	Video &Goto(const int y, const int x, const int v, int v1,int v2);
} video;

#endif	/* __bVIDEO_h */
