#include <ctime>
#include <cmath>
#include <csignal>
#include <cctype>
#include <climits>
#include <vector>
#include <cstdlib>

#include <unistd.h>

#include "play.h"
#include "video.h"
#include "kello.h"
#include "field.h"

/* Copyright (C) 1992,94,99-2002 Bisqwit (http://iki.fi/bisqwit/) */

using namespace std;

// Isn't ansi. Must be declared.
//extern "C" void usleep(unsigned long);

int Quittah=0;

static const unsigned voitto = INT_MAX;
static const unsigned char XOZGE[] = "XOZGE";
static const unsigned char Attrs[] = {9,10,12,13,14};

static double rnd()
{
	return rand() / (1+(double)RAND_MAX);
}
static unsigned Random(unsigned n)
{
	return unsigned(n*rnd());
}

static void Help();
static unsigned char getkey(int wait=0)
{
	unsigned char c;
	for(;;)
	{
		c = video.getkey(wait);
		if(c!='?' && c!='!')break;
		Help();
	}
	return c;
}

static const string Str(int count, const unsigned char n)
{
	string s;
	while(count) s += n, count--;
	return s;
}

static int Pt[5], Cptt[5];

static void Center(const int y, const string &t)
{
	video.Goto(y, (COLS + 1 - t.size()) / 2) << t;
}

static int SubChecker(const int x2,const int y2,const unsigned whom,
					  const int xl,const int yl,const char mrk,
					  const unsigned me)
{
	/* Checks single direction */
	int pit=0, x, y, z;
	unsigned l1=5, l2=5, L1,L2;
	for(z=0,x=x2,y=y2; x+=xl,y+=yl,z<5; z++, pit++)
		if((l1=Alue(x,y).w)!=whom+1)break;
	if(z==5)goto won;
	L1=l1;
	if(l1)l1=0;else while((++l1,x+=xl,y+=yl,!Alue(x,y).w)&&l1<6){}
	for(z=0,x=x2,y=y2; x-=xl,y-=yl,z<5; z++, pit++)	
		if((l2=Alue(x,y).w)!=whom+1)break;
	if(z==5)
	{
won:	for(x=x2,y=y2;;Alue(x,y).w=mrk){x+=xl,y+=yl;if(Alue(x,y).w != whom+1)break;}
		for(x=x2,y=y2;;Alue(x,y).w=mrk){x-=xl,y-=yl;if(Alue(x,y).w != whom+1)break;}
		return voitto;
	}
	if(pit==4)return (voitto-1); /* melkein voitto */
	L2=l2;
	if(l2)l2=0;else while((++l2,x-=xl,y-=yl,!Alue(x,y).w)&&l2<6){}
	
	// Tss vaiheessa
	//    l1 = tilan mr toisessa pss
	//    l2 = toisessa vastaavasti
	//   pit = tuleva pituus, jos thn pistettisiin merkki
	////
	//
	// space = esim jos 'OXX X     ' niin 5+1
	
	//
	//			 2
	//			X
	//		   XOO
	//		  X1XXO     1: 1,5<    >2,0 --- 3,5
	//		 2   O		2: 3,5<    >0,5 --- 3,5
	//
	
	//
	//        X
	//       XcX        
	//        X
	//
	//

	// ...........yyyx
	//              |`- is me?
	//              `-- count
	//          
	
	/* Ei kiinnosta jos ei pituutta */
	if(!pit)return 0;
	
	int space = l1+l2+1;
	if(space+pit>5)space=5-pit;
	
	/* Ei kiinnostusta jos ei tilaa */
	if(space+pit < 5)return 0;
	
	space = !!l1 + !!l2 + pit;
	
	return (whom==me) + (space<<1);
	
	#if 0
	
	return (space + pit >= 5 && pit)
	?
		// 12 lispistett jos molemmista pist tukkimaton
		
		-((pit>1?24:1)*pit*pit*pit
			+ (pit>1)*2*space + (pit>1)*12*(l1&&l2))
	:
		0;
		
	#endif
}

static unsigned CheckPoint(const int x2,const int y2,unsigned CheckWhoPlayer,
                           int Joel,int Joel2)
{
	/* Except range errors! */
	// Parameters:
	//    (x2,y2)        = the point to check
	//    CheckWhoPlayer = whose status are we checking
	//    Joel2          = whose turn is it
	
	// Unused:
	Joel=Joel;		//   = computerplayer intelligency
	
	int l=0, k, j=0;
	if((k=SubChecker(x2,y2,CheckWhoPlayer, 1,0, '-',Joel2)) > 0)j=k;else l-=k;
	if((k=SubChecker(x2,y2,CheckWhoPlayer, 0,1, '|',Joel2)) > 0)j=k;else l-=k;
	if((k=SubChecker(x2,y2,CheckWhoPlayer, 1,1,'\\',Joel2)) > 0)j=k;else l-=k;
	if((k=SubChecker(x2,y2,CheckWhoPlayer,-1,1, '/',Joel2)) > 0)j=k;else l-=k;
	// Now l is unsigned (positive)
	return j?j:l;
}

static void GetNiceInfo()
{
	unsigned x;
	video = 0x4F;
	video.clear();
	for(x=0; x<63; x++)
	{
		video = 0x40 + 7 + (x/32) * 8;
		video.Goto(10 + int(8 * sin(x / 5.0)), 40 + int(20 * cos(x / 5.0))) << 'X';
	}
	string d(
		"                                       "
		"* XOZGE2 is a gomoku clone for five players, made by Joel Yliluoma "
		"21-1-1994, for and with QuickBasic.                         "
		"In the strange years 1996-1999, the game was lost.           "
		"The source code was totally unlocatable, and "
		"Joel supposed it does not exist anymore.                     "
		"Then, 1.10.1999, he found it from an old file archive, "
		"remembered the whole thing and decided to port the game to "
		"Linux and C++.        This is it, the C++-version.      "
		"It seems to work. It took about ten hours to convert it. "
		"Have joy with this freeware game, which has been originally "
		"written by a 15 years old kid! :)                           "
		"Joel Yliluoma is also known as Bisqwit, in the Internet.    "
		"He has there a homepage, at http://iki.fi/bisqwit/ - watch it "
		"when you wish. * ");
	//   0123456789012345678901234567890123456789
	x = 2;
	while(!getkey())
	{
		usleep(100000);
		video = 0x15 + ((x % 4) * 2);
		if(x > 38)
			video.Goto(10,22) << d.substr(x, 38);
		else
			video.Goto(10,60-x) << d.substr(39, x);
		if(++x == d.length()+1)x = 2;
	}
	while(!Quittah && getkey()){}
}

static void Help()
{
	Video swap(video);
	video = 0x17;
	video.clear();
	video.Goto(1,1, 0);
	Center(1, "Some help of this program ...");
    Center(3, "When you run this program from DOS:");
    Center(4, "Usage is XOZGE2 [/Switches]. Shitwes may be /?, then you'll get more help.");
    Center(6, "When you start XOZGE2 without switches or from some sort of MENUprograms,");
    Center(7, "you should first come to crossboard selection.  There are also instructions,");
    Center(8, "so the crossboard is now undocumented in this help system.");
    Center(10, "When the selections are done, game starts.");
    Center(11, "The mission is to get five marks in the same line (before other players).");
    Center(14, "There are two type of players:");
    Center(15, "Humans:     Controlled from keyboard   ");
    Center(16, "Computers:  Controlled automatically,  ");
    Center(17, "              intelligencequotient can ");
    Center(18, "              be selected by user when ");
    Center(19, "              starting.  (Intelligence-");
    Center(20, "              quotient is a number;    ");
    Center(21, "              smaller number, computer ");
    Center(22, "              does more mistakes.)     ");
    Center(24, "XOZGE2 is under GNU general public license. See file \"COPYING\" for details.");
    Center(25, "Hit any key to return, you have read this text...");
	video.getkey(true);
	video.Copy(swap);
}

static void Help2(bool MiscSounds)
{
	int x;
	for(x=0; x<20; x++) video << '\n';
	
	video.Goto(video.wherey()-18, 1, 0);
	
	video = 0x0B; video << Str(COLS, 219) + "\n";
	video = 0x03; video << Str(COLS, 219) + "\n";
	video = 0x09; video << Str(COLS, 219) + "\n";
	video = 0x17; video << "* XOZGE = NEXT GENERATION OF GOMOKU ****** (    LINUX TRANSLATION V"VERSION"      ) *\n";
	int Chooce = 1;
    video = 0x17; video << "" + Str(78, 205) + "\n";
    for(x=0; x<8; x++)
    	video <<           "" + Str(78, 32)  + "\n";
                  video << "" + Str(78, 205) + "\n";
    video.Goto(video.wherey()-9, 3) << "Usage :  xozge2 [switches]\n";
    video.Goto(video.wherey(), 4) << "      --help   This help screen\n";
    video.Goto(video.wherey(), 4) << "       -s1     Go ahead -sounds on\n";
    video.Goto(video.wherey(), 4) << "       -s2     Win- and losesounds off\n";
    video.Goto(video.wherey(), 4) << "      --info   Get some nice information of this game's background\n";
	while(!Quittah)
    {
    	video = 0x0F + Chooce*8;
    	video.Goto(video.wherey()-3, 70) << ",------.\n";
    	video.Goto(video.wherey(), 70)   << "|  OK  |\n";
    	video.Goto(video.wherey(), 70)   << "`------'\n";
    	video = 0x0F + (3-Chooce)*8;
    	video.Goto(video.wherey()-6, 70) << ",------.\n";
    	video.Goto(video.wherey(), 70)   << "| HELP |\n";
    	video.Goto(video.wherey(), 70)   << "`------'\n\n\n\n";
    	while(!Quittah)
    	{
    		int i = getkey();
    		if(i=='\t'){Chooce = 3-Chooce;break;}
    		if(i=='\n'||i=='\r'||i==' ')
    		{
    			if(Chooce==2)return;
    			Help();
    			
    			if(MiscSounds&&!Quittah)Play("t190mqv10ge");
    }	}	}
}

static int MultiPlayers()
{
	//string Ter[4];
	int x, Rivi, Posi;
	video = 0x17;
	video << Str(80, ' ');
	video.Goto(4, 18, 0) << "Welcome!! Insert players to crossboard.\n";
	video = 13; video.Goto(24, 1) << "PS:  This is a QuickBasic -> C++ -translation for Linux, written 1.10.1999\n";
	video = 12; video             << "     Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/)";
	video = 0x1F; video.Goto(18, 79) <<                                           "<";
	video.Goto(19, 1) << Str(79, ' ') <<                                           '';
	video.Goto(20, 23) << "Some help; what do you need to insert to highlighted box";
	video = 8;
	for(x=0; x<5; Cptt[x++]--){}	/* 1000->999, 1->0 */
	for(x=0; x<2; x++)
	{
		video.Goto(10, 1+x*69) << " ";
		video.Goto(11, 1+x*69) << "  ۲";
		video.Goto(12, 1+x*69) << "  ۲";
		video.Goto(13, 1+x*69) << "  ۲";
		video.Goto(14, 1+x*69) << "  ۲";
		video.Goto(15, 1+x*69) << "  ۲";
		video.Goto(16, 1+x*69) << "  ۲";
		video.Goto(17, 1+x*69) << "";
	}
	video = 0x47;
	video.Goto(5, 20) << " The keys are described in there ";
	video.Goto(6, 20) << "             down.               ";
	video.Goto(7, 20) << "  ͻ  ";
	video.Goto(8, 20) << "͹ 1                      ͼ";
	video.Goto(9, 23) <<    "͹";
	video.Goto(10,23) <<    " 2                      ";
	video.Goto(11,23) <<    "͹";
	video.Goto(12,23) <<    " 3                      ";
	video.Goto(13,23) <<    "͹";
	video.Goto(14,23) <<    " 4                      ";
	video.Goto(15,23) <<    "͹";
	video.Goto(16,23) <<    " 5                      ";
	video.Goto(17,23) <<    "ͼ";
	for(x=0; x<5; x++)
	{
		video.Goto(8+x*2, 24);
		video = Attrs[x];
		video << XOZGE[x];
	}
	Rivi=0, Posi=!Quittah;
	do {
		int i = getkey();
		if(i=='H'||i=='A'||i=='w'||i=='i'||i=='')Rivi--;
		if(i=='P'||i=='B'||i=='s'||i=='k'||i=='')Rivi++;
		if(i=='K'||i=='D'||i=='a'||i=='j'||i==''
		|| i=='M'||i=='C'||i=='d'||i=='l'||i=='')Posi=3-Posi;
		if(isdigit(i)&&Posi==2&&Cptt[Rivi]<1000)Cptt[Rivi]=Cptt[Rivi]%100*10+i-'0';
		if(i=='\b'&&Posi==2)Cptt[Rivi]/=10;
		if((i=='\t'||i==' ')&&Posi==1)Pt[Rivi]++;
		if(Rivi==5)Rivi=0;else if(Rivi<0)Rivi=4;
		if(Posi==3)Posi=1;
		if(Pt[Rivi]==-1)Pt[Rivi]=2;
		if(Pt[Rivi]==3)Pt[Rivi]=0;
		if(i=='\n'||i=='\r')break;
		
		int x;
		for(x=0; x<5; x++)
		{
			if(Rivi==x)
			{
				video.Goto(19,1) = 0x1E - Random(6);
				if(Pt[x]==0)video << "empty slot, no player here.                                          ";
				if(Pt[x]==1)video << "This player is a human, world's slaver...  Computer beats it any time!!";
				if(Pt[x]==2)video << "This player is computer, $%%/( you can select it's intelligence!!  ";
			}
			video = 0x47;
			if(Rivi==x && Posi==1)video=0x17, video.Goto(18,1)<<"*** Use the TAB key to toggle between player types, arrows to move ***        ",video=0x17;
			video.Goto(8+x*2, 29);
			if(Pt[x]==0)video << "None             ";
			if(Pt[x]==1)video << "Human            ";
			if(Pt[x]==2)video << "Computer         ";
			video = 0x47;
			if(Rivi==x && Posi==2)
			{
				video = 0x17;
				video.Goto(18, 1);
				if(Pt[x]==2)
					video << "** Insert to this box computerplayer's intelligencequotient **         ";
				else
					video << "    *** Humans intelligencequotient no needed to write here. ***       ";
			}
			video.Goto(8+x*2, 48);
			if(Pt[x]==2)
			{
				static char Buf[4];
				Buf[0] = Cptt[x]/100 + '0';
				Buf[1] = (Cptt[x]/10)%10 + '0';
				Buf[2] = Cptt[x]%10 + '0';
				video << Buf;
			}
			else
				video << "---";
		}
	} while(!Quittah);
	int Prs = 5;
	for(Rivi=0; Rivi<5; Rivi++)
	{
		Cptt[Rivi]++; /* 999->1000, 0->1 */
		Prs -= !Pt[Rivi];
	}
	if(Prs<2)return 1;
	video = 0x17; video.clear();
	return 0;
}

static void TeeAlue(int xmul, int ymul)
{
	video = 7;
	
	Alue.Resize((COLS-22) / xmul, (LINES-2) / ymul);
	
	for(unsigned y=0; y<Alue.ydim; y++)
	{
		video.Goto(2 + y*ymul, 1) << (char)219;
		for(unsigned x=0; x<Alue.xdim; x++)
		{
			video << (char)250;
			for(int c=1; c<xmul; c++)video << ' ';
		}
		video << (char)219;
		for(int c=1; c<ymul; c++)
		{
			video.Goto(2+c + y*xmul, 1) << (char)219;
			video.Goto(video.wherey(), 1+xmul*Alue.xdim) << (char)219;
		}
	}
	video = 0x17;
	video.Goto(1,  1) << Str(Alue.xdim*xmul+2, 220);
	video.Goto(LINES, 1) << Str(Alue.xdim*xmul+2, (char)223);
}

static int Main(bool WinLoseSounds, bool MiscSounds)
{
	video = 7;
	video.clear();
	
	srand(time(NULL));
	
	video.Goto(1,1, 0,0,0);
	
	video = 0x70; video << "           X O Z G E   -   g a m e   w i t h   m a n y   p l a y e r s          \n";
	video = 0x74; video << "                A l l   i s   d o n e   w i t h o u t   p a p e r               \n";
	video = 0x78; video << "                                                                                \n";
	video = 7;
	
	for(unsigned x=0; x<5; Cptt[x++]=1000){}
	
	if(MultiPlayers())return 0;
	
	video = 0x13;
	video.Goto(5,COLS-19) << "Keys:";
	video.Goto(6,COLS-19) << "  arrows: move";
	video.Goto(7,COLS-19) << "  enter: place ";
	video.Goto(8,COLS-19) << "  ctrl-c: end";
	
	unsigned Moves=0, Moves2=0;
	unsigned Vuoro=5, Voitto=0;
	
	unsigned xmul = (LINES < COLS/2) ? 2 : 1;
	unsigned ymul = (COLS < LINES/2) ? 2 : 1;
	
	TeeAlue(xmul,ymul);
	
	unsigned x = Alue.xdim/2;
	unsigned y = Alue.ydim/2;
	
	Kello Kello(COLS-18, (LINES-18/xmul)/2, 17, 17/xmul);
	
	while(!Quittah)
	{
		if(++Vuoro >= 5)
		{
			Vuoro = 0;
			Moves2++;
		}
		
		if(!Pt[Vuoro])continue;
		
		video = 0x17;
		video.Goto(2,COLS-19) << "Player " << 1+Vuoro << "'s turn,\n";
		
		video = Attrs[Vuoro] | 0x10;
		video.Goto(7,COLS-4) << XOZGE[Vuoro];
		
		video = 7; video.Goto(1, 1) << "Investigating...";
		
		if(MiscSounds && Pt[Vuoro]==1 && !Quittah)Play("t120mn<<<v40ab>c");

		video = 0x17;
		video.Goto(3, COLS-19) << "and " << Moves2;
		switch(Moves2 % 10)
		{
			case 1: video << "st"; break;
			case 2: video << "nd"; break;
			case 3: video << "rd"; break;
			default: video << "th";
		}
		video << " round.\n";
		for(int x2=x-4; x2<=(int)x+4; x2++)
			for(int y2=y-4; y2<=(int)y+4; y2++)
				for(unsigned a=0; a<5; a++)
					if(Pt[a])
					{
						unsigned b = CheckPoint(x2,y2, a, Cptt[Vuoro], Vuoro);
						if(b==voitto)
						{
							Voitto=a;
							goto Exit_Do;
						}
						Alue(x2,y2).x[a] = b;
					}
		video = 0x17;
		video.Goto(1, COLS-19) << Moves << " marks in area,";
		video.Goto(1, 1) << Str(19, 220);
		
		switch(Pt[Vuoro])
		{
			case 1:	/* Ihminen */
				for(int ox=-1,oy=-1, bx=x, by=y; !Quittah; )
				{
					bool brk=false;
					
					if(ox!=(int)x || oy!=(int)y)
					{
						ox=x, oy=y;
						video.Goto(LINES-1, COLS-15, 0);
						video = 0x13;
						video << Alue(x,y).x[0] << ':'
							  << Alue(x,y).x[1] << ':'
							  << Alue(x,y).x[2] << ':'
							  << Alue(x,y).x[3] << ':'
							  << Alue(x,y).x[4] << "      ";
					}
					
					video.Goto(2+y*ymul, 2+x*xmul, 1,0,15);
					Kello.Update();
					
					switch(getkey())
					{
						case '4': case 'K': case 'D':
						case 'a': case 'j': case '':
							if(x > 0)x--;
							break;
						case '6': case 'M': case 'C':
						case 'd': case 'l': case '':
							if(x < Alue.xdim-1)x++;
							break;
						case '8': case 'H': case 'A':
						case 'w': case 'i': case '':
							if(y > 0)y--;
							break;
						case '2': case 'P': case 'B':
						case 's': case 'k': case '':
							if(y < Alue.ydim-1)y++;
							break;
						case '\b':
							x=bx, y=by;
							break;
						case ' ': case '\r': case '\n':
							if(!Alue(x,y).w){brk=true; break;}
							video = 0x1C;
							video.Goto(4, COLS-16) << "Not here!!";
							video.Flush();
							sleep(1);
							video.Goto(4, COLS-16) << "          ";
					}
					if(brk)break;
				}
				break;
			case 2:
			{
				vector< pair<unsigned,unsigned> > Eni;
				video = 7;
				video.Goto(1,1, 0) << "Player " << Vuoro << " thinking its move";
				video = 0x87;
				video << ". . .";
			GetPla:
				unsigned z=0;
				int BZ=-1;
				Kello.Update();
				for(unsigned x2=0; x2<Alue.xdim; x2++)
					for(unsigned y2=0; y2<Alue.ydim; y2++)
					{
						if(Alue(x2,y2).w){z++;continue;}
						if(rnd() < Cptt[Vuoro] / 1000.0)
						{
							int a, z2;
							unsigned bg=0, bn=0;
							for(a=z2=0; a<5; a++)
							{
								if(Alue(x2,y2).x[a] > bg)
								{
									bg = Alue(x2,y2).x[a];
									bn = a;
								}
								unsigned tmp = Alue(x2,y2).x[a];
								z2 += tmp*tmp;
							}
								
							/* Eni is a list of equivalent locations
							 *
							 * Now if we get a match, we add this to the
							 * list. If we get better, we clear the list
							 * and put this to the bottom.
							 */
							 
							// (x2,y2) = coordinates
							// z2      = interestingness value
								
							if(z2 < BZ)continue;
							if(z2 > BZ)
							{
								Eni.clear();
								BZ = z2;
							}
							
							Eni.insert(bn==Vuoro ? Eni.begin() : Eni.end(),
								pair<unsigned,unsigned>(x2,y2));
						}
					}
					
				/* TODO: Move this away from here
				 * Let the player have a chance to
				 * win with the last hit
				 */
				if(z == Alue.size())
				{
					video = 0x1E;
					video.Goto(10, 4) << "ͻ";
					video.Goto(11, 4) << " LET'S CLEAR THE AREA NOW ... ";
					video.Goto(12, 4) << "ͼ";
					video.Flush();
					sleep(1);
					TeeAlue(xmul,ymul);
					goto GetPla;
				}
				
				#if 0
			Test:
				#endif
				if(Eni.size())
				{
					x = Eni[0].first;
					y = Eni[0].second;
				}
				else
					do {
						x = Random(Alue.xdim);
						y = Random(Alue.ydim);
					} while(Alue(x,y).w);
				#if 0 // label not used blah blah..
			Vihdoinkin:
				#endif
				video = 0x17;
				video.Goto(1, 1) << Str((Alue.xdim+2)*xmul, 220);
				break;
			}
		}
		video.Goto(2+y*ymul, 2+x*xmul, 0,0,15);
		
		video = Attrs[Vuoro];
		video << XOZGE[Vuoro];
		
		video.Goto(2+y*ymul, 2+x*xmul, 1,0,15);
		
		Alue(x,y).w = Vuoro+1;
		Moves++;
	}
Exit_Do:;
	if(WinLoseSounds && !Quittah)
		Play(Pt[Voitto]!=1
		?	"t270nx64:1,54:3,14:l8mt{vxc16c16<b16>c16gpppc16<bppp>c16<b16>c16gpppc16<b16>c16c16<b16>c16gpppc16<b16>g16f16e16d16c16c<b16a16g,v40<<l32c64pc<b64pba64pag>g16fdc}v30msl1>>c<<<f32r"
		:	"t340nx60:1,30:3,14:vxmnl32{c<aa+>c64fg48c16a64f64d48g16f64e64f|f16*3p16ff64,<fcgf64cd48f16f64c64a+64c64a+64c+64d+64<f64}");
		
	video.Goto(1,COLS-19,1,13,15) << "Pelaaja " << Voitto+1 << " voitti.\n";
	video.Goto(LINES,1) << "*";
	video.Goto(LINES,COLS)<< "*";
	video.Goto(LINES-1,1) << "Pelataanko uudestaan (K / E) [K]\b\b";
	string d(" XOZGE2 - Five-players gomoku was made by Joel Yliluoma 21-1-1994 *");
	unsigned char ke = Quittah?'E':'K';
	for(x=2;!Quittah;)
	{
		unsigned char a=toupper(getkey());
		usleep(40000);
		if(a=='E' || a=='K')
		{
			video = 0x17;
			video << (ke=a) << '\b';
		}
		video = 5 + (x % 4) * 2;
		int y2 = video.wherey();
		int x2 = video.wherex();
		if(x < d.size()+1)
		{
			video.Goto(LINES, 2) << d.substr(d.size()-x, x);
		}
		else
		{
			if(x == d.size()+1)x += 2;
			video.Goto(LINES, x - d.size()) << d.substr(0, COLS - x + d.size());
		}
		if(++x > d.size()+COLS)x = 2;
		time_t z = time(NULL);
		unsigned Z = localtime(&z)->tm_sec;
		if(Z!=y)
		{
			Kello.Update();
			for(video=Attrs[Voitto], y=0; y<Alue.ydim; y++)
				for(unsigned x=0; x<Alue.xdim; x++)
					if(Alue(x,y).w > 5)
					{
						video.Goto(2+y*ymul, 2+x*xmul, 0) << (char)
									(Z%2 ? XOZGE[Voitto] : Alue(x,y).w);
					}
			y=Z;
		}
		video.Goto(y2, x2, 1);
		if(a=='\n')break;
	}
	return ke != 'E';
}

static void CtrlC(int d)
{
	d=d;
	Quittah++;
}
int main(int argc, const char **argv)
{
	signal(SIGINT, CtrlC);
	signal(SIGQUIT, CtrlC);
	
	InitPlay(0, 22050);
	
	bool MiscSounds = false;
	bool WinLoseSounds = true;
	
	while(--argc)
	{
		const char *s = *++argv;
		if(string(s) == "-s1")MiscSounds = true;
		if(string(s) == "-s2")WinLoseSounds = false;
		if(string(s) == "--help") { Help2(MiscSounds); return 0; }
		if(string(s) == "--info") GetNiceInfo();
	}
	while(Main(WinLoseSounds,MiscSounds)){}
	
	DonePlay();
	
	return 0;
}

#if 0
			Essiesitismillismin segmentaatio.

Niin sanotun essiesitismillismin koporativismin ekskulpaatio ei ole
insidenssi, koska sen ekspressiviteetin vitaalisuus ei ole ekstravaganttia.
Essiesitismillismin influenssin extraspektio on osoittanut, ett intiimi,
persoonallinen interpretaatio on paralleeri subkliinisen addiktion kanssa.

Ers tunnettu mritelm: Essiesitismillismin tahtoperinen intensiivisyys
adekvaattisest konstruoi aistimisen, joka toisintaa syy-yhteydellisesti
modifioiden minuuden realisoitumisen, itseisarvovietin muuntumisen
effektiiviseksi, estot eliminoivaksi sinuudeksi, mik on draamallisen
intension tavoke.


#endif
